using System;
using System.Data;
using System.Text;
using System.Data.SqlClient;
using CallCenterApi.DB;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:T_QC_IndexRes
    /// </summary>
    public partial class T_QC_IndexRes
    {
        public T_QC_IndexRes()
        { }
        #region  BasicMethod
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_Id)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_QC_IndexRes with(nolock)");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_QC_IndexRes model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_QC_IndexRes(");
            strSql.Append("CallRecordsId,F_IndexId,F_Score,F_QCScore,F_Remark)");
            strSql.Append(" values (");
            strSql.Append("@CallRecordsId,@F_IndexId,@F_Score,@F_QCScore,@F_Remark)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@CallRecordsId", SqlDbType.Int,4),
                    new SqlParameter("@F_IndexId", SqlDbType.Int,4),
                    new SqlParameter("@F_Score", SqlDbType.Int,4),
                    new SqlParameter("@F_QCScore", SqlDbType.Int,4),
                    new SqlParameter("@F_Remark", SqlDbType.NVarChar,2000)};
            parameters[0].Value = model.CallRecordsId;
            parameters[1].Value = model.F_IndexId;
            parameters[2].Value = model.F_Score;
            parameters[3].Value = model.F_QCScore;
            parameters[4].Value = model.F_Remark;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_QC_IndexRes model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_QC_IndexRes set ");
            strSql.Append("CallRecordsId=@CallRecordsId,");
            strSql.Append("F_IndexId=@F_IndexId,");
            strSql.Append("F_Score=@F_Score,");
            strSql.Append("F_QCScore=@F_QCScore,");
            strSql.Append("F_Remark=@F_Remark");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@CallRecordsId", SqlDbType.Int,4),
                    new SqlParameter("@F_IndexId", SqlDbType.Int,4),
                    new SqlParameter("@F_Score", SqlDbType.Int,4),
                    new SqlParameter("@F_QCScore", SqlDbType.Int,4),
                    new SqlParameter("@F_Remark", SqlDbType.NVarChar,2000),
                    new SqlParameter("@F_Id", SqlDbType.Int,4)};
            parameters[0].Value = model.CallRecordsId;
            parameters[1].Value = model.F_IndexId;
            parameters[2].Value = model.F_Score;
            parameters[3].Value = model.F_QCScore;
            parameters[4].Value = model.F_Remark;
            parameters[5].Value = model.F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_QC_IndexRes ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_Idlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_QC_IndexRes ");
            strSql.Append(" where F_Id in (" + F_Idlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_QC_IndexRes GetModel(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_Id,CallRecordsId,F_IndexId,F_Score,F_QCScore,F_Remark from T_QC_IndexRes with(nolock)");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            CallCenterApi.Model.T_QC_IndexRes model = new CallCenterApi.Model.T_QC_IndexRes();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_QC_IndexRes DataRowToModel(DataRow row)
        {
            CallCenterApi.Model.T_QC_IndexRes model = new CallCenterApi.Model.T_QC_IndexRes();
            if (row != null)
            {
                if (row["F_Id"] != null && row["F_Id"].ToString() != "")
                {
                    model.F_Id = int.Parse(row["F_Id"].ToString());
                }
                if (row["CallRecordsId"] != null && row["CallRecordsId"].ToString() != "")
                {
                    model.CallRecordsId = int.Parse(row["CallRecordsId"].ToString());
                }
                if (row["F_IndexId"] != null && row["F_IndexId"].ToString() != "")
                {
                    model.F_IndexId = int.Parse(row["F_IndexId"].ToString());
                }
                if (row["F_Score"] != null && row["F_Score"].ToString() != "")
                {
                    model.F_Score = int.Parse(row["F_Score"].ToString());
                }
                if (row["F_QCScore"] != null && row["F_QCScore"].ToString() != "")
                {
                    model.F_QCScore = int.Parse(row["F_QCScore"].ToString());
                }
                if (row["F_Remark"] != null)
                {
                    model.F_Remark = row["F_Remark"].ToString();
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_Id,CallRecordsId,F_IndexId,F_Score,F_QCScore,F_Remark ");
            strSql.Append(" FROM T_QC_IndexRes with(nolock)");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_Id,CallRecordsId,F_IndexId,F_Score,F_QCScore,F_Remark ");
            strSql.Append(" FROM T_QC_IndexRes with(nolock)");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_QC_IndexRes with(nolock)");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_Id desc");
            }
            strSql.Append(")AS Row, T.*  from T_QC_IndexRes T with(nolock)");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        #endregion  BasicMethod
    }
}

